jQuery.noConflict();
jQuery(document).ready(function ($) {
	var VIDEOS_PER_LOAD = parseInt($('#db-video-list-wrapper').attr('data-videos-per-load'));

	var hideMoreVideosBtnIfNeeded = function () {
		if ($('.db-videolist-cell').filter(function () {
			return !$(this).is(':visible');
		}).length === 0)
			$('#more-videos').hide();
	};

	$('.db-videolist-cell').slice(0, VIDEOS_PER_LOAD).show();

	hideMoreVideosBtnIfNeeded();

	var minBottom = $('.db-title-overlay').first().css('bottom');
	var maxBottom = $('.db-play-icon').first().css('height');
	$('.db-thumbnail').on({
        'mouseenter': function(){
            $(this).find(".db-title-overlay").stop().animate({bottom: maxBottom});
        }, 
        'mouseleave': function(){
            $(this).find(".db-title-overlay").stop().animate({bottom: minBottom});
        }
    });

    var changeUrlParams = function (changes) {
		var oldUrl = window.location.pathname;

		var queryParameters = {}, queryString = location.search.substring(1),
    		re = /([^&=]+)=([^&]*)/g, m;
 
		while (m = re.exec(queryString)) {
		    queryParameters[decodeURIComponent(m[1])] = decodeURIComponent(m[2]);
		}
		
		for (var key in changes) {
			queryParameters[key] = changes[key];
		}
		location.search = $.param(queryParameters);
    };

    var getURLParameter = function (name) {
    	return decodeURI(
        	(RegExp(name + '=' + '(.+?)(&|$)').exec(location.search)||[,null])[1]
    	);
	}

	var shadeActiveCategory = function () {
		var category = getURLParameter("category");
		var $category = $('.db-category[data-id="' + category + '"]');
		if ($category.length > 0) {
			$category.css('background-color', darkThemeColor);
		} else {
			$('.db-category[data-id=""]').css('background-color', darkThemeColor);
		}
	}

	$('.db-thumbnail').click(function () {
		var id = $(this).attr('data-id');
		changeUrlParams({'video': id});
	});

	$('.db-category').click(function () {
		var id = $(this).attr('data-id');
		changeUrlParams({
			'category': id,
			'video': ""
		});
	});

	$('#more-videos').click(function () {
		$('.db-videolist-cell')
		.filter(function () {
			return !$(this).is(':visible');
		})
		.slice(0, VIDEOS_PER_LOAD)
		//.css('display', 'auto');
		.show();

		hideMoreVideosBtnIfNeeded();
	});

	$('.db-link').click(function (e) {
		e.stopPropagation();
		var link = $(this).attr('data-link');
		$(this).val(link);
		$(this).select();
	});

	/* from http://stackoverflow.com/questions/5560248/programmatically-lighten-or-darken-a-hex-color */
	var shadeColor = function (color, percent) {   
    	var num = parseInt(color.slice(1),16), amt = Math.round(2.55 * percent), R = (num >> 16) + amt, B = (num >> 8 & 0x00FF) + amt, G = (num & 0x0000FF) + amt;
    	return "#" + (0x1000000 + (R<255?R<1?0:R:255)*0x10000 + (B<255?B<1?0:B:255)*0x100 + (G<255?G<1?0:G:255)).toString(16).slice(1);
	}

	var themeColor = $('#db-theme-color').attr('data-color');
	var darkThemeColor,
		lightThemeColor;
		
	if (themeColor) {
		darkThemeColor = shadeColor(themeColor, -15);
		lightThemeColor = shadeColor(themeColor, 15);
	}

	$('#db-category-wrapper').css('background-color', themeColor);
	$('.db-category').hover(
		function() {
			$(this).css('background-color', darkThemeColor);
		}, function() {
			$(this).css('background-color', themeColor);
			shadeActiveCategory();
		}
	);

	$('#more-videos')
	.css('color', themeColor)
	.css('border', '1px solid ' + themeColor);
	$('#more-videos').hover(
		function() {
			$(this).css('background-color', lightThemeColor);
		}, function() {
			$(this).css('background-color', "#fff");
		}
	);

	$('.db-poster, .db-poster-play-wrapper').click(function () {
		var $wrapper = $(this).parents('.db-video-wrapper');
		var videoSource = $wrapper.find('.db-poster').attr('data-video-src');
		$wrapper.find('iframe').attr('src', videoSource);
		$wrapper.find('.db-poster-play-wrapper, .db-poster').remove();
	});

	$('.db-poster-play-bg').css('background-color', themeColor);

	$('.db-poster').each(function () {
		$(this).attr('src', $(this).attr('src') + "?" + new Date().getTime());
	});
	$('.db-poster').load(function () {
		$('.db-poster-play-wrapper').show();
	});

	$('body').click(function () {
		$('.db-link').val("Suora linkki videoon");
	});

	shadeActiveCategory();
});