<?php
/*
Plugin Name: Dream Broker Embed
Plugin URI: 
Description: Plugin to embed Dream Broker channel or video to a Wordpress site.
Author: Dream Broker
Version: 1.1.2
Author URI: http://dreambroker.com/
*/

function exec_shortcode_video($atts) {
	extract(shortcode_atts(array('id' => "", 'controls' => "true"), $atts));
	$channel_id = get_option('db_channel_id');

	$rss = fetch_feed('http://dreambroker.com/channel/' . $channel_id . '.rss');
	$namespace = "http://www.dreambroker.fi/2012/Feed";

	$found = false;
	foreach ($rss->get_items() as $item) {
		$item_id_node = $item->get_item_tags("", "guid");
		$item_id = $item_id_node[0]['data'];
		if (strcmp($id, $item_id) == 0) {
			$found = true;
			break;
		}
	}

	if (!$found)
		return "";

	$channel_id = get_option('db_channel_id');
	$show_controls = strcmp($controls, "false") != 0;
	$src = 'http://dreambroker.com/channel/'.$channel_id.'/iframe/'.$id;
	$result = '<div class="db-video-wrapper"><iframe scrolling="no" frameBorder="0" width="100%" height="100%" allowfullscreen webkitallowfullscreen mozallowfullscreen src="' . ($show_controls ? $src : '') . '"></iframe>';
	if (!$show_controls) {
		$result .= '<img class="db-poster" data-video-src="' . $src . '?autoplay=true' . '" src="http://dreambroker.com/channel/' . $channel_id . '/' . $id . '/get/poster" />
		<div class="db-poster-play-wrapper">
			<div class="db-poster-play-bg"></div>
			<div class="db-poster-play"></div>
		</div><div class="db-poster-vertical-helper"></div>';
	}
	$result .= '</div>';

	return $result;
}

function return_refresh_time () {
	$refresh_time = get_option('db_channel_refresh');
	if (!$refresh_time)
		return 300;

	return $refresh_time;
}

function exec_shortcode_channel() {
	$channel_id = get_option('db_channel_id');

	add_filter('wp_feed_cache_transient_lifetime', 'return_refresh_time');
	$rss = fetch_feed('http://dreambroker.com/channel/' . $channel_id . '.rss');
	$rss->enable_order_by_date(false);
	remove_filter('wp_feed_cache_transient_lifetime', 'return_refresh_time');
	$namespace = "http://www.dreambroker.fi/2012/Feed";

	$channel_title = $rss->get_title();
	$channel_description = $rss->get_description();
	$channel_link = $rss->get_link();

	$category_nodes = $rss->get_channel_tags($namespace, "categories");
	$categories = array();
	$category_items = $category_nodes[0]['child'][$namespace]['categoryItem'];

	if ($category_items) {
		foreach ($category_items as $item) {
			$ns_node = $item['child'][$namespace];
			$id = trim($ns_node['categoryId'][0]['data']);
			$name = $ns_node['category'][0]['data'];
			$level = $ns_node['level'][0]['data'];
			$category = array(
				'id' => $id,
				'name' => $name,
				'level' => $level
			);

			array_push($categories, $category);
		}
	}

	$selected_category_id = isset($_GET["category"]) ? htmlspecialchars($_GET["category"]) : null;
	$selected_video_id = isset($_GET["video"]) ? htmlspecialchars($_GET["video"]) : null;
	$selected_video = null;

	$videos = array();
	foreach ($rss->get_items() as $item) {
		$id = $item->get_item_tags("", "guid");
		$title = $item->get_title();
		$description = $item->get_description();
		$pub_date = $item->get_item_tags("", "pubDate");
		$iframe_src = $item->get_item_tags($namespace, "player");
		$type = $item->get_item_tags("", "type");
		$views = $item->get_item_tags($namespace, "views");
		$thumbnail = $item->get_item_tags($namespace, "thumbnail");
		$category_id = $item->get_item_tags($namespace, "categoryId");
		$link = $item->get_item_tags("", "link");

		$video = array(
			'id' => $id[0]['data'],
			'title' => htmlspecialchars_decode($title),
			'description' => htmlspecialchars_decode($description),
			'pub_date' => date("j.n.Y G:m", strtotime($pub_date[0]['data'])),
			'iframe_src' => $iframe_src[0]['data'],
			'type' => $type[0]['data'],
			'views' => $views[0]['data'],
			'thumbnail' => $thumbnail[0]['data'],
			'category_id' => trim($category_id[0]['data']),
			'link' => $link[0]['data']
		);

		if ($video['type'] == "VIDEO") {
			if ($selected_category_id == null || strcmp($selected_category_id, $video['category_id']) === 0) {
				if ($selected_video_id && strcmp($video['id'], $selected_video_id) === 0)
					$selected_video = $video;
				array_push($videos, $video);
			}
		}
	}

	if (!$selected_video && count($videos) !== 0)
		$selected_video = $videos[0];

	$result = "";

	$show_categories = get_option('db_show_categories');

	include(plugin_dir_path(__FILE__) . 'db-embed-current-video.php');
	if ($category_items && $show_categories)
		include(plugin_dir_path(__FILE__) . 'db-embed-categories.php');
	include(plugin_dir_path(__FILE__) . 'db-embed-video-list.php');

	return $result;
}

function register_shortcodes(){
	add_shortcode('video', 'exec_shortcode_video');
	add_shortcode('db-video', 'exec_shortcode_video');
	add_shortcode('db-channel', 'exec_shortcode_channel');
}

function dbembed_settings() {
	add_menu_page(
		'DB Embed settings',
		'DB Embed',
		'manage_options',
		__FILE__,
		'dbembed_display_settings');
}

function dbembed_display_settings() {
	$channel_id = get_option('db_channel_id');
	$videos_per_load = get_option('db_videos_per_load', 9);
	$show_categories = checked(get_option('db_show_categories'), true, false);
	$channel_refresh = get_option('db_channel_refresh', 300);
	$videos_per_row = get_option('db_videos_per_row', 3);
	$channel_autoplay = checked(get_option('db_autoplay'), true, false);
	$channel_tweet = checked(get_option('db_twitter_share'), true, false);
	$channel_fb_like = checked(get_option('db_fb_like'), true, false);
	$channel_link = checked(get_option('db_link'), true, false);
	$channel_email = checked(get_option('db_email'), true, false);
	$theme_color = get_option('db_theme_color', "#96bf48");

	$html = '<div class="wrap">
		<h2>DB Embed Settings</h2>
		<div class="description">Here you can modify the way videos are embedded on to the site.</div>
		<form action="options.php" method="post" name="options">'
		. screen_icon('generic') . wp_nonce_field('update-options') . '
			<input type="hidden" name="action" value="update" />
			<input type="hidden" name="page_options" value="db_channel_id, db_channel_refresh, db_videos_per_load, db_videos_per_row, db_show_categories, db_autoplay, db_twitter_share, db_fb_like, db_theme_color, db_link, db_email" />
			<table class="form-table">
			<tbody>
			<tr valign="top">
				<th scope="row"><label>Channel ID</label></th>
				<td>
					<input type="text" name="db_channel_id" class="regular-text" value="' . $channel_id . '" />
					<p class="description">Enter here the channel ID of the channel you wish to embed. Example where channel ID is in bold: https://dreambroker.com/<strong>ab1cd2ef</strong>/.</p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><label>Refresh rate (seconds)</label></th>
				<td>
					<input type="number" name="db_channel_refresh" step="1" min="1" max="43200" value="' . $channel_refresh . '" />
					<p class="description">Enter here how often WordPress should fetch the channel feed. Default is 300 (5 minutes).</p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><label>Videos per page</label></th>
				<td>
					<input type="number" step="1" min="1" max="50" name="db_videos_per_load" value="' . $videos_per_load . '" />
					<p class="description">Enter here the number of videos that will be fetched per request in the video library.</p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><label>Videos per row</label></th>
				<td>
					<input type="number" step="1" min="1" max="10" name="db_videos_per_row" value="' . $videos_per_row . '" />
					<p class="description">Enter here the number of videos per row in video list.</p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><label>Theme color</label></th>
				<td>
					<input type="text" value="' . $theme_color . '" name="db_theme_color" id="db-theme-color" />
					<p class="description">Choose the color you want the plugin as the main color in some layout elements.</p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><label>Navigation</label></th>
				<td>
					<label>
						<input type="checkbox" name="db_show_categories" value="1" ' . $show_categories . ' />
						Include Categories
					</label>
					<p class="description">Check this box, if you want the video list to include the category links.</p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><label>Playback</label></th>
				<td>
					<label>
						<input type="checkbox" name="db_autoplay" value="1" ' . $channel_autoplay . ' />
						Autoplay
					</label>
					<p class="description">Check this box, if you want the video to start playing immediately after the page is loaded.</p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><label>Social media</label></th>
				<td>
					<label>
						<input type="checkbox" name="db_twitter_share" value="1" ' . $channel_tweet . ' />
						Twitter: Share
					</label>
					<p class="description">Check this box, if you want to display a twitter share button for the videos.</p>
					<label>
						<input type="checkbox" name="db_fb_like" value="1" ' . $channel_fb_like . ' />
						Facebook: Like
					</label>
					<p class="description">Check this box, if you want to display a Facebook "Like"-button for the videos.</p>
					<label>
						<input type="checkbox" name="db_link" value="1" ' . $channel_link . ' />
						Direct link to video to be copied to clipboard
					</label>
					<p class="description">Check this box, if you want to display a "Direct link to the video" button.</p>
					<label>
						<input type="checkbox" name="db_email" value="1" ' . $channel_email . ' />
						Button to send an email with video link
					</label>
					<p class="description">Check this box, if you want to display a "Share video by email" button.</p>
				</td>
			</tr>
			</tbody>
			</table>
			<p class="submit"><input type="submit" class="button-primary" value="Save Changes" id="submitbutton"/></p>
		</form></div>';

	echo $html;
}

function enqueue_js_and_css() {
	wp_register_style('db-embed', plugins_url('db-embed.css', __FILE__ ));
	wp_enqueue_style('db-embed');
	wp_enqueue_script('jquery');
	wp_enqueue_script('db-embed', plugins_url('db-embed.js', __FILE__));
}

function enqueue_admin_js_and_css($hook_suffix) {
	wp_enqueue_style('wp-color-picker');
	wp_enqueue_script( 'color-picker-handler', plugins_url('color-picker-handler.js', __FILE__ ), array( 'wp-color-picker' ), false, true );
}

add_action('admin_menu', 'dbembed_settings');
add_action('init', 'register_shortcodes');
add_action('wp_enqueue_scripts', 'enqueue_js_and_css');
add_action('admin_enqueue_scripts', 'enqueue_admin_js_and_css');

?>
